<?php
/**
*
* @author Super - Kniffel Smoker ( www.smokers-board.de )
* @author based on Super - Kniffel Bierhasser http://www.phpbb.de/community/memberlist.php?mode=viewprofile&u=3383
*
* @package phpbb3-SuperKniffel
* @version 1.2.0
* @copyright (c) Bierhasser2009
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

if (!defined('IN_PHPBB'))
{
	exit;
}


function quartal_info($monat = false, $jahr = false, $monate = 2)
{
	global $db, $user, $phpbb_root_path, $phpEx, $template, $debug, $monat_name;

	// Mehr als 3 Monate nicht auslesen
	$monate = ($monate > 0 && $monate < 13) ? $monate : 2;
	$now_monat = date("n");
	$now_jahr = date("Y");
	$message = array();
	$have_result = false;
	$show_next = false;
	$show_back = false;

	$jahr = (is_numeric($jahr) && strlen($jahr) == 4 && $jahr <= $now_jahr) ? $jahr : $now_jahr;
	$monat = (int) $monat;
	$monat = ( $jahr == $now_jahr && $monat > $now_monat) ? $now_monat : $monat;
	$monat = ($monat > 0 && $monat < 13) ? $monat + 1 : $now_monat + 1;
	#$debug[] = 'Monat = '.$monat.' Jahr = '.$jahr;

	if ($monat - $monate <= 0)
	{
		$monat = ($monat - $monate) + 12;
		$jahr -= 1;
	}
	else
	{
		$monat -= $monate;
	}

	for ($i = 1; $i <= $monate; $i++)
	{
		if ($jahr == $now_jahr && $monat <= $now_monat || $jahr < $now_jahr )
		{
			$sql = 'SELECT SQL_CALC_FOUND_ROWS k.nr, k.score_date, k.points, k.games, k.score_array, u.user_id AS userid, u.username, u.user_colour
				FROM ' . KNIFFEL_HIGSCORE_TABLE . ' k
				LEFT JOIN ' . USERS_TABLE . ' u on (u.user_id = k.userid)
				WHERE monat = '.$monat.' AND jahr = '.$jahr.'
				ORDER BY points DESC, score_date ASC';
			$result = $db->sql_query_limit($sql, 30);
			// wieviele Zeilen?
			$sql = 'SELECT FOUND_ROWS() as countrows';
			$count = $db->sql_query($sql);
			$countrows = (int) $db->sql_fetchfield('countrows');
			$db->sql_freeresult($count);

			$Rang = 1;

			if ($countrows > 0)
			{
				#$debug[] = '$i = '.$i;
				$have_result = true;
				$backmonat = ($monat == 1) ? 12 : $monat - 1;
				$backjahr = ($backmonat == 12) ? $jahr - 1 : $jahr;
				$link_back = append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=highscore&amp;mon='.$backmonat.'&amp;year='.$backjahr);
				$nextmonat = ($monat == 12) ? 1 : $monat + 1;
				$nextjahr = ($nextmonat == 1) ? $jahr + 1 : $jahr;
				$show_nextlink = ($jahr == $now_jahr && $monat == $now_monat) ? false : true;
				$link_next = append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=highscore&amp;mon='.$nextmonat.'&amp;year='.$nextjahr);
				$template->assign_block_vars('monat_row', array(
						'R_MONAT'	=> $user->lang['datetime'][$monat_name[$monat]],
						'R_YEAR'	=> $jahr,
						'S_SHOW_BACK'	=> ($i == 1) ? true : false,
						'S_SHOW_NEXT'	=> ($i == $monate && $show_nextlink) ? true : false,
						'S_BACK_LINK'	=> $link_back,
						'S_NEXT_LINK'	=> $link_next,
						'L_BACK'	=> $user->lang['datetime'][$monat_name[$backmonat]].' '.$backjahr,
						'L_NEXT'	=> $user->lang['datetime'][$monat_name[$nextmonat]].' '.$nextjahr,
				));

				while ($row = $db->sql_fetchrow($result))
				{
					$show_points_dedails = false;
					if (strlen($row['score_array']) > 1 )
					{
						$show_points_dedails = append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=details&amp;nr='.$row['nr']);
					}
					$template->assign_block_vars('monat_row.monat_info', array(
						'RANG'		=> $Rang,
						'R_IMAGENAME'	=> ($Rang > 3) ? 'no_place' : $Rang,
						'R_NAME'	=> get_username_string('full', $row['userid'], $row['username'], $row['user_colour']),
						'R_POINTS'	=> $row['points'],
						'R_TIME'	=> $user->format_date($row['score_date']),
						'R_GAMES'	=> $row['games'],
						'S_DETAILS'	=> $show_points_dedails,
					));
					$Rang++;
				}
			}
			else
			{
				$message[] = $user->lang['datetime'][$monat_name[$monat]] . ' ' . $jahr;
			}

			$monat += 1;
			if ($monat == 13)
			{
				$monat = 1;
				$jahr += 1;
			}

			$db->sql_freeresult($result);
		}

	}

	if (!$have_result)
	{
		$template->assign_vars(array(
			'L_HIGSCORE_EMPTY_TEXT'	=> sprintf($user->lang['HIGSCORE_EMPTY_TEXT'], implode(",<br />\n", $message)),
			'S_ERROR'		=> true,
			'S_GOBACK'		=> append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=highscore'),
		));
	}
}



/**
* reste ermitteln
* 1 = dreier Pasch / 2 = vierer Pasch / 3 = fünfer Pasch / 4 = doppel Pasch
* 5 = Full House / 6 = kleine Strasse / 7 = große Strasse / 8 = Allee
* 9 = Kniffel
* 20 = gerade / 30 = ungerade
* 2? = Pasch gerade / 3? = Pasch ungerade
* 40 = Triple Pasch / 41 = Crazy Pasch
* Danke an Smoker ( www.smokers-board.de )
* @param string Werte aller Würfel
* @return void
*/
function ermitteln($dummy1)
{
      $dummy = $wert = $kstr = $gstr = $suchen = 0;
      $checker = checker($dummy1);

	// 3er, 4er, 5er Pasch oder Kniffel ???
      for ($i=0; $i< 6;$i++)
	{
            if ($checker[$i] >= 3)
		{
			$dummy=1;        // 3ER PASCH
		}
            if ($checker[$i] >= 4)
		{
			$dummy=2;        // 4ER PASCH
		}
            if ($checker[$i] >= 5)
		{
			$dummy=3;        // 5ER PASCH
		}
            if ($checker[$i] == 6)
		{
			$dummy=9;        // SUPER-KNIFFEL
		}
      }

	// doppel Pasch ???
      for ($i=0; $i< 6;$i++)
	{
            if ($checker[$i]==3)
		{
                  if ($wert==0)
			{
                        $a	=$i+1;             // hier habe ich einen 3er !!!!
                        $wert	=1;                // fehlt noch der andere.
                  }
            }
      }
      if ($wert==1)
	{
            for ($i=$a; $i< 6;$i++)
		{
                  if ($checker[$i]==3)
			{
				$dummy=4;        // DOPPEL PASCH ! der 2te 3er
			}
            }
      }
	// Strasse ???
      $wert=1;
      for ($i=0; $i< 6; $i++)
	{
            if ($checker[$i] != 1)
		{
			$wert=0;                // eine Allee kann nur 6x"1" sein
		}
      }
      if ($wert == 1)
	{
		$dummy=8;                        // ALLEE
	}
      if ($dummy != 8)
	{
            $check=1;
            if ($checker[2] == 0 or $checker[3] == 0)
		{
			$check=0;        // keine strasse möglich
		}
            if ($check == 1) {
			// ab hier werden die strassen gesucht
                  if ($checker[0]>=1 && $checker[1]>=1 && $checker[2]>=1 && $checker[3]>=1 && $checker[4]>=1)
			{
				$gstr=1;
			}
                  if ($checker[1]>=1 && $checker[2]>=1 && $checker[3]>=1 && $checker[4]>=1 && $checker[5]>=1)
			{
				$gstr=1;
			}
                  if ($checker[0]>=1 && $checker[1]>=1 && $checker[2]>=1 && $checker[3]>=1)
			{
				$kstr=1;
			}
                  if ($checker[1]>=1 && $checker[2]>=1 && $checker[3]>=1 && $checker[4]>=1)
			{
				$kstr=1;
			}
                  if ($checker[2]>=1 && $checker[3]>=1 && $checker[4]>=1 && $checker[5]>=1)
			{
				$kstr=1;
			}
            }
      }
      if ($kstr == 1)
	{
		$dummy=6;
	}
      if ($gstr == 1)
	{
		$dummy=7;
	}
	// wenn kleine strasse dann auch 3er pasch ?
      if ($dummy == 6)
	{
            for ($i=0; $i< 6;$i++)
		{
                  if ($checker[$i] == 3)
			{
				$dummy=55;        // 3ER pasch & kl. Strasse
			}
            }
      }
	// Full House ?
      $wert=0;
      for ($i=0;$i< 6;$i++)
	{
            if ($suchen == 0)
		{
                  if ($checker[$i] == 4)
			{
				$suchen=2;
			}
                  if ($checker[$i] == 2)
			{
				$suchen=4;
			}
            }
      }
      if ($suchen != 0)
	{
            for ($i=0;$i< 6;$i++)
		{
                  if ($checker[$i] == $suchen)
			{
				$dummy=5;
			}
            }
      }
	// Triple Pasch
      $wert=0;
      for ($i=0;$i< 6;$i++)
	{
            if ($checker[$i] == 2)
		{
			$wert++;
		}
      }
	if ($wert == 3)
	{
		$dummy=40;
	}
	//Crazy Pasch
      $wert1 = $wert2 = $wert3 = 0;
      for ($i=0;$i< 6;$i++)
	{
            if ($checker[$i] == 1)
		{
			$wert1++;
		}
            if ($checker[$i] == 2)
		{
			$wert2++;
		}
            if ($checker[$i] == 3)
		{
			$wert3++;
		}
      }
      if ($wert1 == 1 && $wert2 == 1 && $wert3 == 1)
	{
		$dummy=41;
	}
	// gerade oder ungerade
	if ($dummy == 1) {
		if ($checker[0] == 0 && $checker[2] == 0 && $checker[4] == 0)
		{
			$dummy=21;
		}
		if ($checker[1] == 0 && $checker[3] == 0 && $checker[5] == 0)
		{
			$dummy=31;
		}
	}
	if ($dummy == 2)
	{
		if ($checker[0] == 0 && $checker[2] == 0 && $checker[4] == 0)
		{
			$dummy=22;
		}
		if ($checker[1] == 0 && $checker[3] == 0 && $checker[5] == 0)
		{
			$dummy=32;
		}
	}
	if ($dummy == 3)
	{
		if ($checker[0] == 0 && $checker[2] == 0 && $checker[4] == 0)
		{
			$dummy=23;
		}
		if ($checker[1] == 0 && $checker[3] == 0 && $checker[5] == 0)
		{
			$dummy=33;
		}
	}
	if ($dummy == 4)
	{
		if ($checker[0] == 0 && $checker[2] == 0 && $checker[4] == 0)
		{
			$dummy=24;
		}
		if ($checker[1] == 0 && $checker[3] == 0 && $checker[5] == 0)
		{
			$dummy=34;
		}
	}
	if ($dummy == 5)
	{
		if ($checker[0] == 0 && $checker[2] == 0 && $checker[4] == 0)
		{
			$dummy=25;
		}
		if ($checker[1] == 0 && $checker[3] == 0 && $checker[5] == 0)
		{
			$dummy=35;
		}
	}
	if ($dummy == 9)
	{
		if ($checker[0] == 0 && $checker[2] == 0 && $checker[4] == 0)
		{
			$dummy=29;
		}
		if ($checker[1] == 0 && $checker[3] == 0 && $checker[5] == 0)
		{
			$dummy=39;
		}
	}
	if ($dummy == 0)
	{
		if ($checker[0] == 0 && $checker[2] == 0 && $checker[4] == 0)
		{
			$dummy=20;        // gerade
		}
		if ($checker[1] == 0 && $checker[3] == 0 && $checker[5] == 0)
		{
			$dummy=30;        // ungerade
		}
	}
	if ($dummy == 40)
	{
		// triple pasch
		if ($checker[0] == 0 && $checker[2] == 0 && $checker[4] == 0)
		{
			$dummy=26;        // gerade
		}
		if ($checker[1] == 0 && $checker[3] == 0 && $checker[5] == 0)
		{
			$dummy=36;        // ungerade
		}
	}
	if ($dummy == 41)
	{
		// crazy pasch
		if ($checker[0] == 0 && $checker[2] == 0 && $checker[4] == 0)
		{
			$dummy=66;        // gerade
		}
		if ($checker[1] == 0 && $checker[3] == 0 && $checker[5] == 0)
		{
			$dummy=76;        // ungerade
		}
	}

	return $dummy;
}

/**
* Wertet alle Ergebnisse aus
* pars template
* @param array Werte von kniffel_user
* @param array Werte von kniffel_wurf
* @return void
*/
function fill_ergebniss($result1 = array(), $result2 = array())
{
	global $template, $phpbb_root_path, $phpEx, $user;

	$auswertung	= array();
	$img		= array();
	$points		= array();
	$text		= array();
	// einer bis sechser
	$nummern = array(1 => 'einer', 2 => 'zweier', 3 => 'dreier', 4 => 'vierer', 5 => 'funfer', 6 => 'sechser');
	foreach ( $nummern AS $k => $v)
	{
		// Mini Grafiken
		$auswertung[$v] = ($result2[$v]) ? miniwurfel($result2[$v],$k) : '';
		// Punkte
		if ($result1[$v] == 99)
		{
			$points[$v] = '';
			$img[$v] = '<a href="'.append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=eintrag&amp;write='.$v).'"><img src="'.$phpbb_root_path.'images/superkniffel/eintrag.gif" alt="" /></a>';
			$text[$v] = '<a href="'.append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=eintrag&amp;write='.$v).'">'.$user->lang['BESCH_'.strtoupper($v)].'</a>';
		}
		else
		{
			$points[$v] = $result1[$v];
			$img[$v] = '<img src="'.$phpbb_root_path.'images/superkniffel/blank.gif" alt="" />';
			$text[$v] = $user->lang['BESCH_'.strtoupper($v)];
		}
	}

	// Der rest
	$rest = array('dpasch', 'vpasch', 'fpasch', 'dopasch', 'gpasch', 'upasch', 'trpasch', 'crpasch', 'fullh', 'kstra', 'gstra', 'allee', 'kniffel', 'chance');
	foreach ( $rest AS $mini)
	{
		// Mini Grafiken
		$auswertung[$mini]	= ($result2[$mini]) ? miniwurfel($result2[$mini],7, true) : '';
		// Punkte
		if ($result1[$mini] == 99)
		{
			$points[$mini] = '';
			$img[$mini] = '<a href="'.append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=eintrag&amp;write='.$mini).'"><img src="'.$phpbb_root_path.'images/superkniffel/eintrag.gif" alt="" /></a>';
			#$img[$mini] = '<a href="'.append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=eintrag&amp;write='.$mini).'"><b class="button2">&raquo;</b></a>';
			$text[$mini] = '<a href="'.append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=eintrag&amp;write='.$mini).'">'.$user->lang['BESCH_'.strtoupper($mini)].'</a>';
		}
		else
		{
			$points[$mini] = $result1[$mini];
			$img[$mini] = '<img src="'.$phpbb_root_path.'images/superkniffel/blank.gif" alt="" />';
			$text[$mini] = $user->lang['BESCH_'.strtoupper($mini)];
		}
	}

	// Template füllen
	foreach ($auswertung AS $k => $v)
	{
		$key = strtoupper($k);

		$template->assign_vars( array(
			// Linkgrafik zum eintragen
			'LI_'.$key => $img[$k],
			// Beschreibungstext
			'B_'.$key => $text[$k],
			// Mini Würfel Grafik
			'W_'.$key => $v,
			// Punkte
			'P_'.$key => $points[$k],
		));
	}

	// ergebnisse Sumieren
	$template->assign_vars(array(
		'SUMME1'	=> $result1['zsumm1'],
		'B_BONUS'	=> $user->lang['BONUS'],
		'BONUS'		=> $result1['bonus'],
		'ERGEBNISS_1'	=> $result1['zsumm1'] + $result1['bonus'],
		'ERGEBNISS_2'	=> $result1['zsumm2'],
		'KONTO'		=> $result1['zsumm1'] + $result1['zsumm2'] + $result1['bonus']
	));
}

/**
* Zählt Augen einer Zahl zusammen
* z.B. '133214' sind die Augen
* ergibt: 2x"1",1x"2",2x"3",1x"4",0x"5",0x"6"
* @param array Augen von Würfel 1-6
* @param int Welche Zahl
* @return string z.b. 212100
*/
function augen($dummy1,$dummy2) {
	$wert = 0;
	for ($i = 0; $i < 6; $i++)
	{
		$wert += ($dummy1[$i] == $dummy2) ? $dummy2 : 0;
	}
	return $wert;
}

/**
* wie oft kommt eine Augenzahl vor
* z.B. '133214' sind die Augen
* ergibt: 2x"1",1x"2",2x"3",1x"4",0x"5",0x"6"
* @param string Augen von Würfel 1-6
* @return string z.b. 212100
*/
function checker($dummy1) {
	$wert=0;
	$checker="";
	for ($i=1; $i< 7; $i++)
	{
		for ($a=0; $a< 6; $a++)
		{
			if ($dummy1[$a] == $i)
			{
				$wert++;
			}
		}
		$checker.=$wert;
		$wert=0;
	}
	return $checker;
}

/**
* Anzeige der Miniwürfel
*
* @param string Anzahl der jeweiligen Würfel
* @param int Welcher Würfel oder 7 für alle 6 Würfel
* @param bool Fehlt ein Würfel mit minivomtisch.gif auffüllen
* @return Miniwürfel Grafiken
*/
function miniwurfel($dummy1,$dummy2, $fill = false)
{
	global $phpbb_root_path;
	$suche = $dummy2-1;
	$dummy = '';
	$c = 0;
	if ($dummy2 == 7)
	{
		// auser (einer - sechser)
		for ($i=0;$i< 6;$i++)
		{
			if ($dummy1[$i] > 0)
			{
				$num=$i+1;
				for ($b=0;$b< $dummy1[$i];$b++)
				{
					$c++;
					$dummy.='<img src="'.$phpbb_root_path.'images/superkniffel/wmini'.$num.'.gif" alt="" />';
				}
			}
		}
	}
	else
	{
		// einer bis sechser
		$a=$dummy1[$suche];
		for ($i=0;$i < $a;$i++)
		{
			$c++;
			$dummy.='<img src="'.$phpbb_root_path.'images/superkniffel/wmini'.$dummy2.'.gif" alt="" />';
		}
	}
	// für schabernack auffüllen
	if ($fill)
	{
		$fehlt = 6 - $c;
		if ($fehlt > 0)
		{
			for ($i =0; $i < $fehlt; $i++)
			{
				$dummy.='<img src="'.$phpbb_root_path.'images/superkniffel/minivomtisch.gif" alt="" />';
			}
		}
	}
	return $dummy;
}

/**
* Anzeige der Knobelbecher Würfel
*
* @param array würfelnummer => Würfelaugen
* @return Würfel Grafiken
*/
function wgrafik($wuerfel = array())
{
	global $template, $debug;
	for ( $i = 0; $i < 6; $i++)
	{
		$a = $i + 1;
		if (strpos($wuerfel[$i], 'random_') !== false)
		{
			$swuerfel = $wuerfel[$i];
		}
		else
		if ($wuerfel[$i] == 15)
		{
			// Vom Tisch gefallen
			$swuerfel = 'vomtisch';
		}
		else
		if ($wuerfel[$i] == 20)
		{
			// Turm nochmal
			$swuerfel = 'turm'.$a;
		}
		else
		{
			$swuerfel = 'wuerfel'.$wuerfel[$i];
		}
		#$debug[] = "Würfel $i = $swuerfel = ".$wuerfel[$i];
		$template->assign_vars( array(
			'W'.$a => $swuerfel.'.gif',
		));
	}
}

/**
* Ermittelt den Bonus für Einer - Sechser
*
* @param init Zahl der Reihe
* @return Bonus
*/
function bonus($summe1)
{
	$re = ((int) $summe1 >= 63) ? 35 : 0;
	$re = ((int) $summe1 >= 85) ? 50 : $re;
	return $re;
}

/**
* @param init Start Zahl
* @param init Stop Zahl
* @return Zufallszahl zwischen $start und $stop
*/
function rand_wuerfel($start, $stop)
{
	if ( function_exists('mt_rand') )
	{
		mt_srand();
		$re = mt_rand($start, $stop);
	}
	else
	{
		srand();
		$re = rand($start, $stop);
	}
	return $re;
}
/**
* Wertet die checkox aus
* Welcher Würfel soll gehalten werden
* Parst das Template
*
* @param array checkboxnummer => 0 oder 1
* @return void
*/
function do_hold ($halte = array())
{
	global $template, $user;
	for ( $i = 1; $i < 7; $i++)
	{
		$a = $i - 1;
		$checked = ( $halte[$a] == 1 ) ? ' checked="checked"': '';
		$template->assign_vars( array(
			'HOLD'.$i => $checked,
		));
	}

	$template->assign_vars( array(
		'S_CHECKBOXES'	=> true,
		'S_HOLD'	=> true,
		'L_HOLD_TITLE'	=> $user->lang['HOLD_TITLE'],
		'L_HOLD'	=> $user->lang['HOLD'],
	));
}

/**
* alle Punkte addieren
* @param array würfel1 bis würfel6
* @return punkte
*/

function punkte($wuerfel = array())
{
	$res = 0;
	for ($i = 0; $i < 6; $i++)
	{
		$res += $wuerfel[$i];
	}
	return $res;
}

/**
* hängt alle Augen aneinander
* @param array würfel1 bis würfel6
* @return string würfel1 bis würfel6
*/
function zate($wuerfel = array())
{
	$zate = '';
	for ($i = 1; $i < 7; $i++)
	{
		$a = $i -1;
		$zate .= $wuerfel[$a];
	}
	return $zate;
}

/**
* Liest die Informationen zu einer Benutzerid
* aus den Tabellen kniffel_user und kniffel:wurf
* @param int Benutzerid
* @return array kniffel_user, kniffel_wurf
*/
function kniffel_info($userid)
{
	global $db, $result, $ergebnis;
		$sql = 'SELECT *
			FROM ' . KNIFFEL_USER_TABLE . '
			WHERE userid = '.$userid;
		$res = $db->sql_query_limit($sql, 1);
		$result = $db->sql_fetchrow($res);
		$db->sql_freeresult($res);

		$sql = 'SELECT *
			FROM ' . KNIFFEL_WURF_TABLE . '
			WHERE userid = '.$userid;
		$res = $db->sql_query_limit($sql, 1);
		$ergebnis = $db->sql_fetchrow($res);
		$db->sql_freeresult($res);
	return array($result, $ergebnis);
}

function simple_hiscore($anzahl = 3, $return = false, $alltime = false)
{
	global $db, $neu, $result, $user, $phpbb_root_path, $uid, $debug;
	// Highscore ermitteln
	$best	= $vergleich = array();
	$show_hiscore = $own = false;
	$monat = date("n");
	$jahr	= date("Y");
	$Rang	= 1;
	$anzahl = (intval($anzahl) > 0) ? intval($anzahl) : 1;
	$row_feld = ($return) ? ', k.nr, k.score_array' : false;

	$sql = 'SELECT k.score_date, k.points, u.user_id AS userid, u.username, u.user_colour'.$row_feld.'
		FROM ' . KNIFFEL_HIGSCORE_TABLE . ' k
		LEFT JOIN ' . USERS_TABLE .' u on (u.user_id = k.userid)
		'.( (!$alltime) ? 'WHERE monat = '.$monat.' AND jahr = '.$jahr : '').'
		ORDER BY points DESC, score_date ASC';
	$high = $db->sql_query_limit($sql, $anzahl);
 	#$debug[] = '$sql = '.$sql;

	while ($row = $db->sql_fetchrow($high))
	{
		$colored_name = get_username_string('full', $row['userid'], $row['username'], $row['user_colour']);
		$reihe = array($row['userid'], $row['points'], $colored_name, $row['score_date']);
		if ($row_feld)
		{
			array_push($reihe, $row['nr'], $row['score_array']);
		}
		$best[] = $reihe;
	}
	$db->sql_freeresult($high);

	// Alltime Rekord?
	if ($alltime)
	{
		return $best;
	}

	$C = count($best);
	if ($C > 0)
	{
		$show_hiscore = true;
		$konto = $result['zsumm1'] + $result['zsumm2'] + $result['bonus'];
		for ($i = 0; $i < $C; $i++)
		{
			$image_name = ($Rang > 3) ? 'no_place' : $Rang;
			$rang_image = '<img src="'.$phpbb_root_path.'images/superkniffel/'.$image_name.'.gif" alt="" />';
			if ($neu == 0 and $result['zaehler'] > 0 and !$own)
			{
				$diff = $best[$i][1] - $konto;
				$own = ($best[$i][0] == $uid) ? true : false;
				if ($konto < $best[$i][1])
				{
					#$debug[] = 'konto kleiner best';
					$vergleich[] = ($own) ? sprintf($user->lang['SCORE_DIFF_3'], $diff, $best[$i][1], $Rang, $rang_image) : sprintf($user->lang['SCORE_DIFF_1'], $diff, $Rang, $best[$i][2], $best[$i][1], $rang_image);
				}
				else
				{
					$vergleich[] = ($own or $konto > $best[$i][1]) ? sprintf($user->lang['SCORE_DIFF_2'], get_username_string('full', $uid, $user->data['username'], $user->data['user_colour']), $konto, $Rang, $rang_image) : sprintf($user->lang['SCORE_DIFF_3'], $diff, $best[$i][1], $Rang, $rang_image);
				}
			}
			else
			{
				$konto = ($neu == 1 OR $result['zaehler'] == 0) ? $best[$i][1] : $konto;
				$konto = $best[$i][1];
				$own = ($best[$i][0] == $uid) ? true : false;
				$vergleich[] = ($own) ? sprintf($user->lang['SCORE_DIFF_2'], get_username_string('full', $uid, $user->data['username'], $user->data['user_colour']), $konto, $Rang, $rang_image) : '<b>'.$Rang.'</b>.'.$user->lang['PLACE'] .' '. sprintf($user->lang['SCORE_INFO'], $best[$i][2], $best[$i][1], $rang_image);
			}
			$Rang++;
		}
	}
	return ($show_hiscore) ? $vergleich : false;
}


function safe_config($new = array(0) )
{
	global $auth, $phpbb_root_path, $phpEx;

	if ($auth->acl_get('a_') != 1 )
	{
		trigger_error('NO_AUTH_ADMIN', E_USER_ERROR);
	}

	// ist im array überhaupt ein wert?
	if ( count($new) <= 1 )
	{
		return false;
	}

	$CONF = array();
	//neue Werte $CONF zuweisen
	foreach( $new as $k => $v )
	{
		if ( strlen($k) > 0 )
		{
			$v = preg_replace( "/'/", "\\'" , $v );
			$v = preg_replace( "/\r|\n/", ""   , $v );
			$CONF[ $k ] = $v;
		}
	}

	// existiert eine _bak = löschen
	if (file_exists($phpbb_root_path.'includes/conf_superkniffel_bak.'.$phpEx))
	{
		@unlink($phpbb_root_path.'includes/conf_superkniffel_bak.'.$phpEx);
	}

	// alte _conf sichern
	if (file_exists($phpbb_root_path.'includes/conf_superkniffel.'.$phpEx))
	{
		@rename($phpbb_root_path.'includes/conf_superkniffel.'.$phpEx, $phpbb_root_path.'includes/conf_superkniffel_bak.'.$phpEx);
	}

	phpbb_chmod($phpbb_root_path.'includes/conf_superkniffel_bak.'.$phpEx, CHMOD_ALL);

	ksort($CONF);

	$file_string = '<?php
/**
*
* @author Super - Kniffel Smoker ( www.smokers-board.de )
* @author based on Super - Kniffel Bierhasser http://www.phpbb.de/community/memberlist.php?mode=viewprofile&u=3383
*
* @package phpbb3-SuperKniffel
* @version 1.2.0
* @copyright (c) Bierhasser2009
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/';
	foreach( $CONF as $k => $v )
	{
		$v = ( is_numeric($v) ) ? (int)$v : "'$v'";
		$file_string .= "\n" . '$CONF[\'' . $k . '\'] = ' . $v . ';';
	}
	$file_string .= "\n?>";

	// schreibe neue conf_
	if ( $fh = fopen($phpbb_root_path.'includes/conf_superkniffel.'.$phpEx, 'w' ) )
	{
		fwrite($fh, $file_string, strlen($file_string) );
		fclose($fh);
		phpbb_chmod($phpbb_root_path.'includes/conf_superkniffel.'.$phpEx, CHMOD_ALL);
		// existiert eine _bak = löschen
		if (file_exists($phpbb_root_path.'includes/conf_superkniffel_bak.'.$phpEx))
		{
			@unlink($phpbb_root_path.'includes/conf_superkniffel_bak.'.$phpEx);
		}
	}
	else
	{
		// konnte nicht schreiben. Alte _bak herstellen
		if (file_exists($phpbb_root_path.'includes/conf_superkniffel_bak.'.$phpEx))
		{
			@rename($phpbb_root_path.'includes/conf_superkniffel_bak.'.$phpEx, $phpbb_root_path.'includes/conf_superkniffel.'.$phpEx);
		}
		trigger_error('Schwerer Fehler. Kann conf_superkniffel.php nicht zum Schreiben öffnen - keine Änderungen durchgeführt. Versuche CHMOD auf 0777 zu ändern. Eventuell kann im Verzeichnis includes nicht geschrieben werden?<br />'. __FILE__.' '.__LINE__, E_USER_ERROR);
	}
	return $CONF;
}
?>