#
# $Id: $
#


# Table: 'phpbb_kniffel_highscore'
CREATE TABLE phpbb_kniffel_highscore (
	nr INTEGER NOT NULL,
	userid INTEGER DEFAULT 0 NOT NULL,
	monat INTEGER DEFAULT 0 NOT NULL,
	jahr INTEGER DEFAULT 0 NOT NULL,
	score_date INTEGER DEFAULT 0 NOT NULL,
	points INTEGER DEFAULT 0 NOT NULL,
	games INTEGER DEFAULT 1 NOT NULL,
	score_array BLOB SUB_TYPE TEXT CHARACTER SET UTF8 NOT NULL
);;

ALTER TABLE phpbb_kniffel_highscore ADD PRIMARY KEY (nr);;

CREATE INDEX phpbb_kniffel_highscore_monat ON phpbb_kniffel_highscore(points,score_date);;
CREATE INDEX phpbb_kniffel_highscore_jahr ON phpbb_kniffel_highscore(jahr);;

CREATE GENERATOR phpbb_kniffel_highscore_gen;;
SET GENERATOR phpbb_kniffel_highscore_gen TO 0;;

CREATE TRIGGER t_phpbb_kniffel_highscore FOR phpbb_kniffel_highscore
BEFORE INSERT
AS
BEGIN
	NEW.nr = GEN_ID(phpbb_kniffel_highscore_gen, 1);
END;;


# Table: 'phpbb_kniffel_wurf'
CREATE TABLE phpbb_kniffel_wurf (
	userid INTEGER DEFAULT 0 NOT NULL,
	einer CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	zweier CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	dreier CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	vierer CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	funfer CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	sechser CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	dpasch CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	vpasch CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	fpasch CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	dopasch CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	trpasch CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	crpasch CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	gpasch CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	upasch CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	fullh CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	kstra CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	gstra CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	allee CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	kniffel CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL,
	chance CHAR(6) CHARACTER SET NONE DEFAULT 0 NOT NULL
);;

ALTER TABLE phpbb_kniffel_wurf ADD PRIMARY KEY (userid);;


# Table: 'phpbb_kniffel_user'
CREATE TABLE phpbb_kniffel_user (
	userid INTEGER DEFAULT 0 NOT NULL,
	wurf INTEGER DEFAULT 0 NOT NULL,
	wurfel1 INTEGER DEFAULT 0 NOT NULL,
	wurfel2 INTEGER DEFAULT 0 NOT NULL,
	wurfel3 INTEGER DEFAULT 0 NOT NULL,
	wurfel4 INTEGER DEFAULT 0 NOT NULL,
	wurfel5 INTEGER DEFAULT 0 NOT NULL,
	wurfel6 INTEGER DEFAULT 0 NOT NULL,
	zaehler INTEGER DEFAULT 0 NOT NULL,
	einer INTEGER DEFAULT 99 NOT NULL,
	zweier INTEGER DEFAULT 99 NOT NULL,
	dreier INTEGER DEFAULT 99 NOT NULL,
	vierer INTEGER DEFAULT 99 NOT NULL,
	funfer INTEGER DEFAULT 99 NOT NULL,
	sechser INTEGER DEFAULT 99 NOT NULL,
	dpasch INTEGER DEFAULT 99 NOT NULL,
	vpasch INTEGER DEFAULT 99 NOT NULL,
	fpasch INTEGER DEFAULT 99 NOT NULL,
	dopasch INTEGER DEFAULT 99 NOT NULL,
	trpasch INTEGER DEFAULT 99 NOT NULL,
	crpasch INTEGER DEFAULT 99 NOT NULL,
	gpasch INTEGER DEFAULT 99 NOT NULL,
	upasch INTEGER DEFAULT 99 NOT NULL,
	fullh INTEGER DEFAULT 99 NOT NULL,
	kstra INTEGER DEFAULT 99 NOT NULL,
	gstra INTEGER DEFAULT 99 NOT NULL,
	allee INTEGER DEFAULT 99 NOT NULL,
	kniffel INTEGER DEFAULT 99 NOT NULL,
	chance INTEGER DEFAULT 99 NOT NULL,
	bonus INTEGER DEFAULT 0 NOT NULL,
	zsumm1 INTEGER DEFAULT 0 NOT NULL,
	zsumm2 INTEGER DEFAULT 0 NOT NULL,
	games INTEGER DEFAULT 1 NOT NULL,
	c1 INTEGER DEFAULT 0 NOT NULL,
	c2 INTEGER DEFAULT 0 NOT NULL,
	c3 INTEGER DEFAULT 0 NOT NULL,
	c4 INTEGER DEFAULT 0 NOT NULL,
	c5 INTEGER DEFAULT 0 NOT NULL,
	c6 INTEGER DEFAULT 0 NOT NULL
);;

ALTER TABLE phpbb_kniffel_user ADD PRIMARY KEY (userid);;


