/*

 $Id: $

*/

BEGIN TRANSACTION
GO

/*
	Table: 'phpbb_kniffel_highscore'
*/
CREATE TABLE [phpbb_kniffel_highscore] (
	[nr] [int] IDENTITY (1, 1) NOT NULL ,
	[userid] [int] DEFAULT (0) NOT NULL ,
	[monat] [int] DEFAULT (0) NOT NULL ,
	[jahr] [int] DEFAULT (0) NOT NULL ,
	[score_date] [int] DEFAULT (0) NOT NULL ,
	[points] [int] DEFAULT (0) NOT NULL ,
	[games] [int] DEFAULT (1) NOT NULL ,
	[score_array] [varchar] (4000) NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [phpbb_kniffel_highscore] WITH NOCHECK ADD 
	CONSTRAINT [PK_phpbb_kniffel_highscore] PRIMARY KEY  CLUSTERED 
	(
		[nr]
	)  ON [PRIMARY] 
GO

CREATE  INDEX [monat] ON [phpbb_kniffel_highscore]([points,score_date]) ON [PRIMARY]
GO

CREATE  INDEX [jahr] ON [phpbb_kniffel_highscore]([jahr]) ON [PRIMARY]
GO


/*
	Table: 'phpbb_kniffel_wurf'
*/
CREATE TABLE [phpbb_kniffel_wurf] (
	[userid] [int] DEFAULT (0) NOT NULL ,
	[einer] [char] (6) DEFAULT (0) NOT NULL ,
	[zweier] [char] (6) DEFAULT (0) NOT NULL ,
	[dreier] [char] (6) DEFAULT (0) NOT NULL ,
	[vierer] [char] (6) DEFAULT (0) NOT NULL ,
	[funfer] [char] (6) DEFAULT (0) NOT NULL ,
	[sechser] [char] (6) DEFAULT (0) NOT NULL ,
	[dpasch] [char] (6) DEFAULT (0) NOT NULL ,
	[vpasch] [char] (6) DEFAULT (0) NOT NULL ,
	[fpasch] [char] (6) DEFAULT (0) NOT NULL ,
	[dopasch] [char] (6) DEFAULT (0) NOT NULL ,
	[trpasch] [char] (6) DEFAULT (0) NOT NULL ,
	[crpasch] [char] (6) DEFAULT (0) NOT NULL ,
	[gpasch] [char] (6) DEFAULT (0) NOT NULL ,
	[upasch] [char] (6) DEFAULT (0) NOT NULL ,
	[fullh] [char] (6) DEFAULT (0) NOT NULL ,
	[kstra] [char] (6) DEFAULT (0) NOT NULL ,
	[gstra] [char] (6) DEFAULT (0) NOT NULL ,
	[allee] [char] (6) DEFAULT (0) NOT NULL ,
	[kniffel] [char] (6) DEFAULT (0) NOT NULL ,
	[chance] [char] (6) DEFAULT (0) NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [phpbb_kniffel_wurf] WITH NOCHECK ADD 
	CONSTRAINT [PK_phpbb_kniffel_wurf] PRIMARY KEY  CLUSTERED 
	(
		[userid]
	)  ON [PRIMARY] 
GO


/*
	Table: 'phpbb_kniffel_user'
*/
CREATE TABLE [phpbb_kniffel_user] (
	[userid] [int] DEFAULT (0) NOT NULL ,
	[wurf] [int] DEFAULT (0) NOT NULL ,
	[wurfel1] [int] DEFAULT (0) NOT NULL ,
	[wurfel2] [int] DEFAULT (0) NOT NULL ,
	[wurfel3] [int] DEFAULT (0) NOT NULL ,
	[wurfel4] [int] DEFAULT (0) NOT NULL ,
	[wurfel5] [int] DEFAULT (0) NOT NULL ,
	[wurfel6] [int] DEFAULT (0) NOT NULL ,
	[zaehler] [int] DEFAULT (0) NOT NULL ,
	[einer] [int] DEFAULT (99) NOT NULL ,
	[zweier] [int] DEFAULT (99) NOT NULL ,
	[dreier] [int] DEFAULT (99) NOT NULL ,
	[vierer] [int] DEFAULT (99) NOT NULL ,
	[funfer] [int] DEFAULT (99) NOT NULL ,
	[sechser] [int] DEFAULT (99) NOT NULL ,
	[dpasch] [int] DEFAULT (99) NOT NULL ,
	[vpasch] [int] DEFAULT (99) NOT NULL ,
	[fpasch] [int] DEFAULT (99) NOT NULL ,
	[dopasch] [int] DEFAULT (99) NOT NULL ,
	[trpasch] [int] DEFAULT (99) NOT NULL ,
	[crpasch] [int] DEFAULT (99) NOT NULL ,
	[gpasch] [int] DEFAULT (99) NOT NULL ,
	[upasch] [int] DEFAULT (99) NOT NULL ,
	[fullh] [int] DEFAULT (99) NOT NULL ,
	[kstra] [int] DEFAULT (99) NOT NULL ,
	[gstra] [int] DEFAULT (99) NOT NULL ,
	[allee] [int] DEFAULT (99) NOT NULL ,
	[kniffel] [int] DEFAULT (99) NOT NULL ,
	[chance] [int] DEFAULT (99) NOT NULL ,
	[bonus] [int] DEFAULT (0) NOT NULL ,
	[zsumm1] [int] DEFAULT (0) NOT NULL ,
	[zsumm2] [int] DEFAULT (0) NOT NULL ,
	[games] [int] DEFAULT (1) NOT NULL ,
	[c1] [int] DEFAULT (0) NOT NULL ,
	[c2] [int] DEFAULT (0) NOT NULL ,
	[c3] [int] DEFAULT (0) NOT NULL ,
	[c4] [int] DEFAULT (0) NOT NULL ,
	[c5] [int] DEFAULT (0) NOT NULL ,
	[c6] [int] DEFAULT (0) NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [phpbb_kniffel_user] WITH NOCHECK ADD 
	CONSTRAINT [PK_phpbb_kniffel_user] PRIMARY KEY  CLUSTERED 
	(
		[userid]
	)  ON [PRIMARY] 
GO



COMMIT
GO

