/*

 $Id: $

*/

/*
  This first section is optional, however its probably the best method
  of running phpBB on Oracle. If you already have a tablespace and user created
  for phpBB you can leave this section commented out!

  The first set of statements create a phpBB tablespace and a phpBB user,
  make sure you change the password of the phpBB user before you run this script!!
*/

/*
CREATE TABLESPACE "PHPBB"
	LOGGING 
	DATAFILE 'E:\ORACLE\ORADATA\LOCAL\PHPBB.ora' 
	SIZE 10M
	AUTOEXTEND ON NEXT 10M
	MAXSIZE 100M;

CREATE USER "PHPBB" 
	PROFILE "DEFAULT" 
	IDENTIFIED BY "phpbb_password" 
	DEFAULT TABLESPACE "PHPBB" 
	QUOTA UNLIMITED ON "PHPBB" 
	ACCOUNT UNLOCK;

GRANT ANALYZE ANY TO "PHPBB";
GRANT CREATE SEQUENCE TO "PHPBB";
GRANT CREATE SESSION TO "PHPBB";
GRANT CREATE TABLE TO "PHPBB";
GRANT CREATE TRIGGER TO "PHPBB";
GRANT CREATE VIEW TO "PHPBB";
GRANT "CONNECT" TO "PHPBB";

COMMIT;
DISCONNECT;

CONNECT phpbb/phpbb_password;
*/
/*
	Table: 'phpbb_kniffel_highscore'
*/
CREATE TABLE phpbb_kniffel_highscore (
	nr number(11) NOT NULL,
	userid number(11) DEFAULT '0' NOT NULL,
	monat number(1) DEFAULT '0' NOT NULL,
	jahr number(4) DEFAULT '0' NOT NULL,
	score_date number(11) DEFAULT '0' NOT NULL,
	points number(11) DEFAULT '0' NOT NULL,
	games number(11) DEFAULT '1' NOT NULL,
	score_array clob NOT NULL,
	CONSTRAINT pk_phpbb_kniffel_highscore PRIMARY KEY (nr)
)
/

CREATE INDEX phpbb_kniffel_highscore_monat ON phpbb_kniffel_highscore (points,score_date)
/
CREATE INDEX phpbb_kniffel_highscore_jahr ON phpbb_kniffel_highscore (jahr)
/

CREATE SEQUENCE phpbb_kniffel_highscore_seq
/

CREATE OR REPLACE TRIGGER t_phpbb_kniffel_highscore
BEFORE INSERT ON phpbb_kniffel_highscore
FOR EACH ROW WHEN (
	new.nr IS NULL OR new.nr = 0
)
BEGIN
	SELECT phpbb_kniffel_highscore_seq.nextval
	INTO :new.nr
	FROM dual;
END;
/


/*
	Table: 'phpbb_kniffel_wurf'
*/
CREATE TABLE phpbb_kniffel_wurf (
	userid number(11) DEFAULT '0' NOT NULL,
	einer char(6) DEFAULT '0' NOT NULL,
	zweier char(6) DEFAULT '0' NOT NULL,
	dreier char(6) DEFAULT '0' NOT NULL,
	vierer char(6) DEFAULT '0' NOT NULL,
	funfer char(6) DEFAULT '0' NOT NULL,
	sechser char(6) DEFAULT '0' NOT NULL,
	dpasch char(6) DEFAULT '0' NOT NULL,
	vpasch char(6) DEFAULT '0' NOT NULL,
	fpasch char(6) DEFAULT '0' NOT NULL,
	dopasch char(6) DEFAULT '0' NOT NULL,
	trpasch char(6) DEFAULT '0' NOT NULL,
	crpasch char(6) DEFAULT '0' NOT NULL,
	gpasch char(6) DEFAULT '0' NOT NULL,
	upasch char(6) DEFAULT '0' NOT NULL,
	fullh char(6) DEFAULT '0' NOT NULL,
	kstra char(6) DEFAULT '0' NOT NULL,
	gstra char(6) DEFAULT '0' NOT NULL,
	allee char(6) DEFAULT '0' NOT NULL,
	kniffel char(6) DEFAULT '0' NOT NULL,
	chance char(6) DEFAULT '0' NOT NULL,
	CONSTRAINT pk_phpbb_kniffel_wurf PRIMARY KEY (userid)
)
/


/*
	Table: 'phpbb_kniffel_user'
*/
CREATE TABLE phpbb_kniffel_user (
	userid number(11) DEFAULT '0' NOT NULL,
	wurf number(1) DEFAULT '0' NOT NULL,
	wurfel1 number(1) DEFAULT '0' NOT NULL,
	wurfel2 number(1) DEFAULT '0' NOT NULL,
	wurfel3 number(1) DEFAULT '0' NOT NULL,
	wurfel4 number(1) DEFAULT '0' NOT NULL,
	wurfel5 number(1) DEFAULT '0' NOT NULL,
	wurfel6 number(1) DEFAULT '0' NOT NULL,
	zaehler number(1) DEFAULT '0' NOT NULL,
	einer number(1) DEFAULT '99' NOT NULL,
	zweier number(1) DEFAULT '99' NOT NULL,
	dreier number(1) DEFAULT '99' NOT NULL,
	vierer number(1) DEFAULT '99' NOT NULL,
	funfer number(1) DEFAULT '99' NOT NULL,
	sechser number(1) DEFAULT '99' NOT NULL,
	dpasch number(1) DEFAULT '99' NOT NULL,
	vpasch number(1) DEFAULT '99' NOT NULL,
	fpasch number(1) DEFAULT '99' NOT NULL,
	dopasch number(1) DEFAULT '99' NOT NULL,
	trpasch number(1) DEFAULT '99' NOT NULL,
	crpasch number(1) DEFAULT '99' NOT NULL,
	gpasch number(1) DEFAULT '99' NOT NULL,
	upasch number(1) DEFAULT '99' NOT NULL,
	fullh number(1) DEFAULT '99' NOT NULL,
	kstra number(1) DEFAULT '99' NOT NULL,
	gstra number(1) DEFAULT '99' NOT NULL,
	allee number(1) DEFAULT '99' NOT NULL,
	kniffel number(1) DEFAULT '99' NOT NULL,
	chance number(1) DEFAULT '99' NOT NULL,
	bonus number(1) DEFAULT '0' NOT NULL,
	zsumm1 number(4) DEFAULT '0' NOT NULL,
	zsumm2 number(4) DEFAULT '0' NOT NULL,
	games number(11) DEFAULT '1' NOT NULL,
	c1 number(1) DEFAULT '0' NOT NULL,
	c2 number(1) DEFAULT '0' NOT NULL,
	c3 number(1) DEFAULT '0' NOT NULL,
	c4 number(1) DEFAULT '0' NOT NULL,
	c5 number(1) DEFAULT '0' NOT NULL,
	c6 number(1) DEFAULT '0' NOT NULL,
	CONSTRAINT pk_phpbb_kniffel_user PRIMARY KEY (userid)
)
/


